package javax.management.modelmbean;

import java.security.AccessController;
import com.sun.jmx.mbeanserver.GetPropertyAction;
import java.io.ObjectOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import javax.management.RuntimeOperationsException;
import javax.management.IntrospectionException;
import java.util.logging.Level;
import com.sun.jmx.defaults.JmxProperties;
import java.lang.reflect.Method;
import javax.management.Descriptor;
import java.io.ObjectStreamField;
import javax.management.DescriptorAccess;
import javax.management.MBeanAttributeInfo;

public class ModelMBeanAttributeInfo extends MBeanAttributeInfo implements DescriptorAccess
{
    private static final long oldSerialVersionUID = 7098036920755973145L;
    private static final long newSerialVersionUID = 6181543027787327345L;
    private static final ObjectStreamField[] oldSerialPersistentFields;
    private static final ObjectStreamField[] newSerialPersistentFields;
    private static final long serialVersionUID;
    private static final ObjectStreamField[] serialPersistentFields;
    private static boolean compat;
    private Descriptor attrDescriptor;
    private static final String currClass = "ModelMBeanAttributeInfo";
    
    public ModelMBeanAttributeInfo(String s, String description, Method getter, Method setter) throws IntrospectionException {
        super(s, description, getter, setter);
        this.attrDescriptor = this.validDescriptor(null);
        if (JmxProperties.MODELMBEAN_LOGGER.isLoggable(Level.FINER)) {
            JmxProperties.MODELMBEAN_LOGGER.logp(Level.FINER, ModelMBeanAttributeInfo.class.getName(), "ModelMBeanAttributeInfo(String,String,Method,Method)", "Entry", s);
        }
        this.attrDescriptor = this.validDescriptor(null);
    }
    
    public ModelMBeanAttributeInfo(String s, String description, Method getter, Method setter, Descriptor descriptor) throws IntrospectionException {
        super(s, description, getter, setter);
        this.attrDescriptor = this.validDescriptor(null);
        if (JmxProperties.MODELMBEAN_LOGGER.isLoggable(Level.FINER)) {
            JmxProperties.MODELMBEAN_LOGGER.logp(Level.FINER, ModelMBeanAttributeInfo.class.getName(), "ModelMBeanAttributeInfo(String,String,Method,Method,Descriptor)", "Entry", s);
        }
        this.attrDescriptor = this.validDescriptor(descriptor);
    }
    
    public ModelMBeanAttributeInfo(String s, String type, String description, boolean isReadable, boolean isWritable, boolean isIs) {
        super(s, type, description, isReadable, isWritable, isIs);
        this.attrDescriptor = this.validDescriptor(null);
        if (JmxProperties.MODELMBEAN_LOGGER.isLoggable(Level.FINER)) {
            JmxProperties.MODELMBEAN_LOGGER.logp(Level.FINER, ModelMBeanAttributeInfo.class.getName(), "ModelMBeanAttributeInfo(String,String,String,boolean,boolean,boolean)", "Entry", s);
        }
        this.attrDescriptor = this.validDescriptor(null);
    }
    
    public ModelMBeanAttributeInfo(String s, String type, String description, boolean isReadable, boolean isWritable, boolean isIs, Descriptor descriptor) {
        super(s, type, description, isReadable, isWritable, isIs);
        this.attrDescriptor = this.validDescriptor(null);
        if (JmxProperties.MODELMBEAN_LOGGER.isLoggable(Level.FINER)) {
            JmxProperties.MODELMBEAN_LOGGER.logp(Level.FINER, ModelMBeanAttributeInfo.class.getName(), "ModelMBeanAttributeInfo(String,String,String,boolean,boolean,boolean,Descriptor)", "Entry", s);
        }
        this.attrDescriptor = this.validDescriptor(descriptor);
    }
    
    public ModelMBeanAttributeInfo(ModelMBeanAttributeInfo modelMBeanAttributeInfo) {
        super(modelMBeanAttributeInfo.getName(), modelMBeanAttributeInfo.getType(), modelMBeanAttributeInfo.getDescription(), modelMBeanAttributeInfo.isReadable(), modelMBeanAttributeInfo.isWritable(), modelMBeanAttributeInfo.isIs());
        this.attrDescriptor = this.validDescriptor(null);
        if (JmxProperties.MODELMBEAN_LOGGER.isLoggable(Level.FINER)) {
            JmxProperties.MODELMBEAN_LOGGER.logp(Level.FINER, ModelMBeanAttributeInfo.class.getName(), "ModelMBeanAttributeInfo(ModelMBeanAttributeInfo)", "Entry");
        }
        this.attrDescriptor = this.validDescriptor(modelMBeanAttributeInfo.getDescriptor());
    }
    
    @Override
    public Descriptor getDescriptor() {
        if (JmxProperties.MODELMBEAN_LOGGER.isLoggable(Level.FINER)) {
            JmxProperties.MODELMBEAN_LOGGER.logp(Level.FINER, ModelMBeanAttributeInfo.class.getName(), "getDescriptor()", "Entry");
        }
        if (this.attrDescriptor == null) {
            this.attrDescriptor = this.validDescriptor(null);
        }
        return (Descriptor)this.attrDescriptor.clone();
    }
    
    @Override
    public void setDescriptor(Descriptor descriptor) {
        this.attrDescriptor = this.validDescriptor(descriptor);
    }
    
    @Override
    public Object clone() {
        if (JmxProperties.MODELMBEAN_LOGGER.isLoggable(Level.FINER)) {
            JmxProperties.MODELMBEAN_LOGGER.logp(Level.FINER, ModelMBeanAttributeInfo.class.getName(), "clone()", "Entry");
        }
        return new ModelMBeanAttributeInfo(this);
    }
    
    @Override
    public String toString() {
        return "ModelMBeanAttributeInfo: " + this.getName() + " ; Description: " + this.getDescription() + " ; Types: " + this.getType() + " ; isReadable: " + this.isReadable() + " ; isWritable: " + this.isWritable() + " ; Descriptor: " + this.getDescriptor();
    }
    
    private Descriptor validDescriptor(Descriptor descriptor) throws RuntimeOperationsException {
        int n = descriptor == null;
        DescriptorSupport descriptorSupport;
        if (!(n == 0)) {
            descriptorSupport = new DescriptorSupport();
            JmxProperties.MODELMBEAN_LOGGER.finer("Null Descriptor, creating new.");
        }
        else {
            descriptorSupport = (Descriptor)descriptor.clone();
        }
        if (n && descriptorSupport.getFieldValue("name") == null) {
            descriptorSupport.setField("name", this.getName());
            JmxProperties.MODELMBEAN_LOGGER.finer("Defaulting Descriptor name to " + this.getName());
        }
        if (n && descriptorSupport.getFieldValue("descriptorType") == null) {
            descriptorSupport.setField("descriptorType", "attribute");
            JmxProperties.MODELMBEAN_LOGGER.finer("Defaulting descriptorType to \"attribute\"");
        }
        if (descriptorSupport.getFieldValue("displayName") == null) {
            descriptorSupport.setField("displayName", this.getName());
            JmxProperties.MODELMBEAN_LOGGER.finer("Defaulting Descriptor displayName to " + this.getName());
        }
        if (!descriptorSupport.isValid()) {
            throw new RuntimeOperationsException(new IllegalArgumentException("Invalid Descriptor argument"), "The isValid() method of the Descriptor object itself returned false,one or more required fields are invalid. Descriptor:" + descriptorSupport.toString());
        }
        if (!this.getName().equalsIgnoreCase((String)descriptorSupport.getFieldValue("name"))) {
            throw new RuntimeOperationsException(new IllegalArgumentException("Invalid Descriptor argument"), "The Descriptor \"name\" field does not match the object described.  Expected: " + this.getName() + " , was: " + descriptorSupport.getFieldValue("name"));
        }
        if (!"attribute".equalsIgnoreCase((String)descriptorSupport.getFieldValue("descriptorType"))) {
            throw new RuntimeOperationsException(new IllegalArgumentException("Invalid Descriptor argument"), "The Descriptor \"descriptorType\" field does not match the object described.  Expected: \"attribute\" , was: " + descriptorSupport.getFieldValue("descriptorType"));
        }
        return descriptorSupport;
    }
    
    private void readObject(ObjectInputStream objectInputStream) throws IOException, ClassNotFoundException {
        objectInputStream.defaultReadObject();
    }
    
    private void writeObject(ObjectOutputStream objectOutputStream) throws IOException {
        if (ModelMBeanAttributeInfo.compat) {
            ObjectOutputStream.PutField putFields = objectOutputStream.putFields();
            putFields.put("attrDescriptor", this.attrDescriptor);
            putFields.put("currClass", "ModelMBeanAttributeInfo");
            objectOutputStream.writeFields();
        }
        else {
            objectOutputStream.defaultWriteObject();
        }
    }
    
    static {
        oldSerialPersistentFields = new ObjectStreamField[] { new ObjectStreamField("attrDescriptor", Descriptor.class), new ObjectStreamField("currClass", String.class) };
        newSerialPersistentFields = new ObjectStreamField[] { new ObjectStreamField("attrDescriptor", Descriptor.class) };
        ModelMBeanAttributeInfo.compat = false;
        try {
            String s = (String)AccessController.doPrivileged(new GetPropertyAction("jmx.serial.form"));
            ModelMBeanAttributeInfo.compat = (s != null && s.equals("1.0"));
        }
        catch (Exception ex) {}
        if (ModelMBeanAttributeInfo.compat) {
            serialPersistentFields = ModelMBeanAttributeInfo.oldSerialPersistentFields;
            serialVersionUID = 7098036920755973145L;
        }
        else {
            serialPersistentFields = ModelMBeanAttributeInfo.newSerialPersistentFields;
            serialVersionUID = 6181543027787327345L;
        }
    }
}
